Dieser Inhalt ist in der von Ihnen ausgewählten Sprache nicht verfügbar.
Chapter 5. Enabling monitoring for user-defined projects
In OpenShift Container Platform, you can enable monitoring for user-defined projects in addition to the default platform monitoring. You can monitor your own projects in OpenShift Container Platform without the need for an additional monitoring solution. Using this feature centralizes monitoring for core platform components and user-defined projects.
Versions of Prometheus Operator installed using Operator Lifecycle Manager (OLM) are not compatible with user-defined monitoring. Therefore, custom Prometheus instances installed as a Prometheus custom resource (CR) managed by the OLM Prometheus Operator are not supported in OpenShift Container Platform.
5.1. Enabling monitoring for user-defined projects Link kopierenLink in die Zwischenablage kopiert!
Cluster administrators can enable monitoring for user-defined projects by setting the
enableUserWorkload: true
ConfigMap
You must remove any custom Prometheus instances before enabling monitoring for user-defined projects.
You must have access to the cluster as a user with the
cluster-admin
Prerequisites
-
You have access to the cluster as a user with the cluster role.
cluster-admin -
You have installed the OpenShift CLI ().
oc -
You have created the
cluster-monitoring-configobject.ConfigMap You have optionally created and configured the
user-workload-monitoring-configobject in theConfigMapproject. You can add configuration options to thisopenshift-user-workload-monitoringobject for the components that monitor user-defined projects.ConfigMapNoteEvery time you save configuration changes to the
user-workload-monitoring-configobject, the pods in theConfigMapproject are redeployed. It might sometimes take a while for these components to redeploy.openshift-user-workload-monitoring
Procedure
Edit the
cluster-monitoring-configobject:ConfigMap$ oc -n openshift-monitoring edit configmap cluster-monitoring-configAdd
underenableUserWorkload: true:data/config.yamlapiVersion: v1 kind: ConfigMap metadata: name: cluster-monitoring-config namespace: openshift-monitoring data: config.yaml: | enableUserWorkload: true1 - 1
- When set to
true, theenableUserWorkloadparameter enables monitoring for user-defined projects in a cluster.
Save the file to apply the changes. Monitoring for user-defined projects is then enabled automatically.
NoteIf you enable monitoring for user-defined projects, the
user-workload-monitoring-configobject is created by default.ConfigMapVerify that the
,prometheus-operator, andprometheus-user-workloadpods are running in thethanos-ruler-user-workloadproject. It might take a short while for the pods to start:openshift-user-workload-monitoring$ oc -n openshift-user-workload-monitoring get podExample output
NAME READY STATUS RESTARTS AGE prometheus-operator-6f7b748d5b-t7nbg 2/2 Running 0 3h prometheus-user-workload-0 4/4 Running 1 3h prometheus-user-workload-1 4/4 Running 1 3h thanos-ruler-user-workload-0 3/3 Running 0 3h thanos-ruler-user-workload-1 3/3 Running 0 3h
5.2. Granting users permission to monitor user-defined projects Link kopierenLink in die Zwischenablage kopiert!
As a cluster administrator, you can monitor all core OpenShift Container Platform and user-defined projects.
You can also grant developers and other users different permissions:
- Monitoring user-defined projects
- Configuring the components that monitor user-defined projects
- Configuring alert routing for user-defined projects
- Managing alerts and silences for user-defined projects
You can grant the permissions by assigning one of the following monitoring roles or cluster roles:
| Role name | Description | Project |
|---|---|---|
|
| Users with this role can edit the
|
|
|
| Users with this role have read access to the user-defined Alertmanager API for all projects, if the user-defined Alertmanager is enabled. |
|
|
| Users with this role have read and write access to the user-defined Alertmanager API for all projects, if the user-defined Alertmanager is enabled. |
|
| Cluster role name | Description | Project |
|---|---|---|
|
| Users with this cluster role have read access to
| Can be bound with
|
|
| Users with this cluster role can create, modify, and delete
| Can be bound with
|
|
| Users with this cluster role have the same privileges as users with the
| Can be bound with
|
|
| Users with this cluster role can create, update, and delete
| Can be bound with
|
5.2.1. Granting user permissions by using the web console Link kopierenLink in die Zwischenablage kopiert!
You can grant users permissions for the
openshift-monitoring
Prerequisites
-
You have access to the cluster as a user with the cluster role.
cluster-admin - The user account that you are assigning the role to already exists.
Procedure
-
In the Administrator perspective of the OpenShift Container Platform web console, go to User Management
RoleBindings Create binding. - In the Binding Type section, select the Namespace Role Binding type.
- In the Name field, enter a name for the role binding.
In the Namespace field, select the project where you want to grant the access.
ImportantThe monitoring role or cluster role permissions that you grant to a user by using this procedure apply only to the project that you select in the Namespace field.
- Select a monitoring role or cluster role from the Role Name list.
- In the Subject section, select User.
- In the Subject Name field, enter the name of the user.
- Select Create to apply the role binding.
5.2.2. Granting user permissions by using the CLI Link kopierenLink in die Zwischenablage kopiert!
You can grant users permissions for the
openshift-monitoring
oc
Whichever role or cluster role you choose, you must bind it against a specific project as a cluster administrator.
Prerequisites
-
You have access to the cluster as a user with the cluster role.
cluster-admin - The user account that you are assigning the role to already exists.
-
You have installed the OpenShift CLI ().
oc
Procedure
To assign a monitoring role to a user for a project, enter the following command:
$ oc adm policy add-role-to-user <role> <user> -n <namespace> --role-namespace <namespace>1 - 1
- Substitute
<role>with the wanted monitoring role,<user>with the user to whom you want to assign the role, and<namespace>with the project where you want to grant the access.
To assign a monitoring cluster role to a user for a project, enter the following command:
$ oc adm policy add-cluster-role-to-user <cluster-role> <user> -n <namespace>1 - 1
- Substitute
<cluster-role>with the wanted monitoring cluster role,<user>with the user to whom you want to assign the cluster role, and<namespace>with the project where you want to grant the access.
5.3. Granting users permission to configure monitoring for user-defined projects Link kopierenLink in die Zwischenablage kopiert!
As a cluster administrator, you can assign the
user-workload-monitoring-config-edit
Prerequisites
-
You have access to the cluster as a user with the cluster role.
cluster-admin - The user account that you are assigning the role to already exists.
-
You have installed the OpenShift CLI ().
oc
Procedure
Assign the
role to a user in theuser-workload-monitoring-config-editproject:openshift-user-workload-monitoring$ oc -n openshift-user-workload-monitoring adm policy add-role-to-user \ user-workload-monitoring-config-edit <user> \ --role-namespace openshift-user-workload-monitoringVerify that the user is correctly assigned to the
role by displaying the related role binding:user-workload-monitoring-config-edit$ oc describe rolebinding <role_binding_name> -n openshift-user-workload-monitoringExample command
$ oc describe rolebinding user-workload-monitoring-config-edit -n openshift-user-workload-monitoringExample output
Name: user-workload-monitoring-config-edit Labels: <none> Annotations: <none> Role: Kind: Role Name: user-workload-monitoring-config-edit Subjects: Kind Name Namespace ---- ---- --------- User user11 - 1
- In this example,
user1is assigned to theuser-workload-monitoring-config-editrole.
5.4. Accessing metrics from outside the cluster for custom applications Link kopierenLink in die Zwischenablage kopiert!
You can query Prometheus metrics from outside the cluster when monitoring your own services with user-defined projects. Access this data from outside the cluster by using the
thanos-querier
This access only supports using a bearer token for authentication.
Prerequisites
- You have deployed your own service, following the "Enabling monitoring for user-defined projects" procedure.
-
You are logged in to an account with the cluster role, which provides permission to access the Thanos Querier API.
cluster-monitoring-view You are logged in to an account that has permission to get the Thanos Querier API route.
NoteIf your account does not have permission to get the Thanos Querier API route, a cluster administrator can provide the URL for the route.
Procedure
Extract an authentication token to connect to Prometheus by running the following command:
$ TOKEN=$(oc whoami -t)Extract the
API route URL by running the following command:thanos-querier$ HOST=$(oc -n openshift-monitoring get route thanos-querier -ojsonpath='{.status.ingress[].host}')Set the namespace to the namespace in which your service is running by using the following command:
$ NAMESPACE=ns1Query the metrics of your own services in the command line by running the following command:
$ curl -H "Authorization: Bearer $TOKEN" -k "https://$HOST/api/v1/query?" --data-urlencode "query=up{namespace='$NAMESPACE'}"The output shows the status for each application pod that Prometheus is scraping:
The formatted example output
{ "status": "success", "data": { "resultType": "vector", "result": [ { "metric": { "__name__": "up", "endpoint": "web", "instance": "10.129.0.46:8080", "job": "prometheus-example-app", "namespace": "ns1", "pod": "prometheus-example-app-68d47c4fb6-jztp2", "service": "prometheus-example-app" }, "value": [ 1591881154.748, "1" ] } ], } }Note-
The formatted example output uses a filtering tool, such as , to provide the formatted indented JSON. See the jq Manual (jq documentation) for more information about using
jq.jq - The command requests an instant query endpoint of the Thanos Querier service, which evaluates selectors at one point in time.
-
The formatted example output uses a filtering tool, such as
5.5. Excluding a user-defined project from monitoring Link kopierenLink in die Zwischenablage kopiert!
Individual user-defined projects can be excluded from user workload monitoring. To do so, simply add the
openshift.io/user-monitoring
false
Procedure
Add the label to the project namespace:
$ oc label namespace my-project 'openshift.io/user-monitoring=false'To re-enable monitoring, remove the label from the namespace:
$ oc label namespace my-project 'openshift.io/user-monitoring-'NoteIf there were any active monitoring targets for the project, it may take a few minutes for Prometheus to stop scraping them after adding the label.
5.6. Disabling monitoring for user-defined projects Link kopierenLink in die Zwischenablage kopiert!
After enabling monitoring for user-defined projects, you can disable it again by setting
enableUserWorkload: false
ConfigMap
Alternatively, you can remove
enableUserWorkload: true
Procedure
Edit the
cluster-monitoring-configobject:ConfigMap$ oc -n openshift-monitoring edit configmap cluster-monitoring-configSet
toenableUserWorkload:underfalse:data/config.yamlapiVersion: v1 kind: ConfigMap metadata: name: cluster-monitoring-config namespace: openshift-monitoring data: config.yaml: | enableUserWorkload: false
- Save the file to apply the changes. Monitoring for user-defined projects is then disabled automatically.
Check that the
,prometheus-operatorandprometheus-user-workloadpods are terminated in thethanos-ruler-user-workloadproject. This might take a short while:openshift-user-workload-monitoring$ oc -n openshift-user-workload-monitoring get podExample output
No resources found in openshift-user-workload-monitoring project.
The
user-workload-monitoring-config
ConfigMap
openshift-user-workload-monitoring
ConfigMap